/* eslint-disable @typescript-eslint/no-empty-function */
import React, { createContext, useCallback, useContext, useEffect, useMemo, useState } from "react";
import useWebSocket, { ReadyState } from "react-use-websocket";
var ConnectionContext = createContext({
    connectionStatus: ReadyState.UNINSTANTIATED,
    sendMessage: function () { },
    lastMessage: null,
    changeConnectionUrl: function () { }
});
var ConnectionProvider = function (_a) {
    var children = _a.children, socketUrl = _a.socketUrl, options = _a.options;
    var _b = useState(""), connectionUrl = _b[0], setConnectionUrl = _b[1];
    var _c = useWebSocket(connectionUrl, options), readyState = _c.readyState, sendJsonMessage = _c.sendJsonMessage, lastJsonMessage = _c.lastJsonMessage;
    useEffect(function () {
        setConnectionUrl(socketUrl);
    }, [socketUrl]);
    var changeConnectionUrl = useCallback(function (url) {
        setConnectionUrl(url);
    }, []);
    var sendMessage = useCallback(function (message) {
        sendJsonMessage(message);
    }, [sendJsonMessage]);
    var contextValue = useMemo(function () {
        return {
            connectionStatus: readyState,
            changeConnectionUrl: changeConnectionUrl,
            sendMessage: sendMessage,
            lastMessage: lastJsonMessage
        };
    }, [changeConnectionUrl, lastJsonMessage, readyState, sendMessage]);
    var Provider = ConnectionContext.Provider;
    return React.createElement(Provider, { value: contextValue }, children);
};
export var useConnection = function () { return useContext(ConnectionContext); };
export default ConnectionProvider;
//# sourceMappingURL=ConnectionProvider.js.map